﻿Public Class frmPrehPal

    Private TblMaterialBindingSourceCopy As BindingSource
    Private Sub TblPaletyBindingNavigatorSaveItem_Click(sender As Object, e As EventArgs)
        Me.Validate()
        Me.TblPaletyBindingSource.EndEdit()
        Me.TableAdapterManager.UpdateAll(Me.DsData)

    End Sub

    Private Sub frmPrehPal_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        'TODO: This line of code loads data into the 'DsData.tblMaterial' table. You can move, or remove it, as needed.
        Me.TblMaterialTableAdapter.Fill(Me.DsData.tblMaterial)
        'TODO: This line of code loads data into the 'DsData.tblStavyPalet' table. You can move, or remove it, as needed.
        Me.TblStavyPaletTableAdapter.Fill(Me.DsData.tblStavyPalet)
        'TODO: This line of code loads data into the 'DsData.tblTypyPalet' table. You can move, or remove it, as needed.
        Me.TblTypyPaletTableAdapter.Fill(Me.DsData.tblTypyPalet)
        'TODO: This line of code loads data into the 'DsData.tblPalety' table. You can move, or remove it, as needed.
        Me.TblPaletyTableAdapter.Fill(Me.DsData.tblPalety)


        ''kopie Bindingsourcu
        TblMaterialBindingSourceCopy = New BindingSource(TblMaterialBindingSource.DataSource, TblMaterialBindingSource.DataMember)
        cmbMaterial.DataSource = TblMaterialBindingSourceCopy

    End Sub

    Private Sub btnPrvni_Click(sender As Object, e As EventArgs) Handles btnPrvni.Click
        TblPaletyBindingSource.MoveFirst()
    End Sub

    Private Sub btnPosledni_Click(sender As Object, e As EventArgs) Handles btnPosledni.Click
        TblPaletyBindingSource.MoveLast()
    End Sub

    Private Sub TblPaletyBindingSource_PositionChanged(sender As Object, e As EventArgs) Handles TblPaletyBindingSource.PositionChanged

        If TblPaletyBindingSource.Current Is Nothing OrElse IsDBNull(TblPaletyBindingSource.Current("ID_Materialu")) Then
            TblMaterialBindingSource.Filter = "ID_Materialu IS NULL "
            tbMnozCelk.Text = ""
            ErrorProvider.SetError(tbMnozCelk, "")
            btnRezervace.Enabled = True
            btnZmenaObsahu.Enabled = False
            Exit Sub
        End If

        Dim currIDMat As Integer = TblPaletyBindingSource.Current("ID_Materialu")

        TblMaterialBindingSource.Filter = "ID_Materialu = " & currIDMat

        Dim strSQL As String = "SELECT SUM(Mnoz_pa) AS CelkoveMnozstvi FROM tblPalety WHERE ID_Materialu = " & currIDMat
        Dim dvCelkMnoz As DataView = SpustSQL(strSQL)
        Dim CelkoveMnozstvi As Integer = IIf(IsDBNull(dvCelkMnoz(0)("CelkoveMnozstvi")), 0, dvCelkMnoz(0)("CelkoveMnozstvi"))
        tbMnozCelk.Text = CelkoveMnozstvi

        If CelkoveMnozstvi <= CInt(tbMnozPoj.Text) Then
            ErrorProvider.SetError(tbMnozCelk, "Pozor, jste pod pojistnou zásobou")
        Else
            ErrorProvider.SetError(tbMnozCelk, "")
        End If

        refreshZaskVyskl()

        btnRezervace.Enabled = False
        btnZmenaObsahu.Enabled = True

    End Sub

    Sub refreshZaskVyskl(Optional ulozitdoDB As Boolean = False)

        Dim stav As Integer = TblPaletyBindingSource.Current("ID_Stav_Pa")
        Dim pozice As Integer = TblStavyPaletBindingSource.Find("ID_Stav_Pa", stav)
        lblStav.Text = "Stav: " & TblStavyPaletBindingSource(pozice)("Popis")

        Select Case stav
            Case StavyPalet.Zaskladnena 'zaskladnena
                btnZaskladnit.Enabled = False
                btnVyskladnit.Enabled = True
                btnZaskladnit.Text = "Zaskladnit"
                btnVyskladnit.Text = "Vyskladnit do dopravy"
            Case StavyPalet.Vyskladnena 'vyskladnena
                btnZaskladnit.Enabled = True
                btnVyskladnit.Enabled = False
                btnZaskladnit.Text = "Zaskladnit do dopravy"
                btnVyskladnit.Text = "Vyskladnit"
            Case StavyPalet.VDoprave 'v doprave
                btnZaskladnit.Enabled = True
                btnVyskladnit.Enabled = True
                btnZaskladnit.Text = "Zaskladnit"
                btnVyskladnit.Text = "Vyskladnit"
        End Select

        'dgvPalety.Refresh()

        If ulozitdoDB Then
            Try
                TblPaletyBindingSource.EndEdit()
                TblPaletyTableAdapter.Update(DsData.tblPalety)
            Catch ex As Exception
                VypisChybu(ex, "Nepodařilo se změněný stav uložit do databáze.")
            End Try
        End If

    End Sub

    Private Sub btnZaskladnit_Click(sender As Object, e As EventArgs) Handles btnZaskladnit.Click
        If TblPaletyBindingSource.Current("ID_Stav_Pa") = StavyPalet.VDoprave Then
            TblPaletyBindingSource.Current("ID_Stav_Pa") = StavyPalet.Zaskladnena
        Else
            TblPaletyBindingSource.Current("ID_Stav_Pa") = StavyPalet.VDoprave
        End If

        refreshZaskVyskl(True)

    End Sub
    Private Sub btnVyskladnit_Click(sender As Object, e As EventArgs) Handles btnVyskladnit.Click
        ''po vyskladneni jde do dopravy
        If TblPaletyBindingSource.Current("ID_Stav_Pa") = StavyPalet.VDoprave Then
            TblPaletyBindingSource.Current("ID_Stav_Pa") = StavyPalet.Vyskladnena
        Else
            TblPaletyBindingSource.Current("ID_Stav_Pa") = StavyPalet.VDoprave
        End If


        refreshZaskVyskl(True)
    End Sub

    Private Sub btnZavrit_Click(sender As Object, e As EventArgs) Handles btnZavrit.Click
        Me.Close()
    End Sub


    Private Sub dgvPalety_RowPostPaint(sender As Object, e As DataGridViewRowPostPaintEventArgs) Handles dgvPalety.RowPostPaint
        Dim dgv As DataGridView = CType(sender, DataGridView)
        Dim row As DataGridViewRow = dgv.Rows(e.RowIndex)

        Dim cellstyle As DataGridViewCellStyle = New DataGridViewCellStyle()

        Try

            Select Case dgv.Rows(e.RowIndex).Cells("colStav").Value
                Case StavyPalet.Zaskladnena
                    row.DefaultCellStyle.BackColor = Color.LightGoldenrodYellow
                Case StavyPalet.Vyskladnena
                    row.DefaultCellStyle.BackColor = Color.LightSkyBlue
                Case StavyPalet.VDoprave
                    row.DefaultCellStyle.BackColor = Color.LightGreen
            End Select


        Catch ex As Exception

        End Try
    End Sub

    Private Sub dgvPalety_RowPrePaint(sender As Object, e As DataGridViewRowPrePaintEventArgs) Handles dgvPalety.RowPrePaint
        Dim dgv As DataGridView = CType(sender, DataGridView)

        If dgv.Rows(e.RowIndex).Selected Then
            Dim row = dgv.Rows(e.RowIndex)
            Dim bgColor = row.DefaultCellStyle.BackColor
            row.DefaultCellStyle.SelectionBackColor = Color.FromArgb(bgColor.R * 5 / 6, bgColor.G * 5 / 6, bgColor.B * 5 / 6)
        End If


    End Sub

    Private Sub btnOdstranit_Click(sender As Object, e As EventArgs) Handles btnOdstranit.Click
        Dim vys As MsgBoxResult
        If tbMnozPa.Text <> 0 Then
            MsgBox("Nelze odstanit paletu s nenulovým obsahem", MsgBoxStyle.Information + MsgBoxStyle.OkOnly)
        Else
            vys = MsgBox("Opravdu zrušit paletu " & TblPaletyBindingSource.Current("ID_Palety") & "?", MsgBoxStyle.YesNo + MsgBoxStyle.Question, "Smazat")
            If vys = MsgBoxResult.Yes Then
                'Odpoved byla "ano"
                Try
                    Me.TblPaletyBindingSource.RemoveCurrent()
                    TblPaletyBindingSource.EndEdit()
                    TblPaletyTableAdapter.Update(DsData.tblPalety)
                Catch ex As Exception
                    VypisChybu(ex, "Paleta nebyla odstraněna z databáze.")
                End Try

            End If
        End If
    End Sub

    Sub VypisChybu(ex As Exception, textchyby As String)
        MsgBox(textchyby & vbNewLine & ex.ToString _
               , MsgBoxStyle.Critical + MsgBoxStyle.OkOnly, "CHYBA")

    End Sub


    Public Enum StavyPalet
        Zadny
        Zaskladnena
        Vyskladnena
        VDoprave
    End Enum

    Sub RezimEditace(editace As Boolean, rezim As Integer)

        Me.pnlAkce.Enabled = Not editace
        Me.pnlZasklVyskl.Enabled = Not editace
        Me.pnlNavig.Enabled = Not editace
        Me.pnlDalsiAkce.Enabled = Not editace
        Me.pnlZmenaObsahu.Enabled = Not editace

        Me.pnlUkladani.Enabled = editace

        tbKoment.Enabled = editace

        btnZavrit.Enabled = Not editace
        dgvPalety.Enabled = Not editace

        For Each ctr In pnlPalety.Controls
            CType(ctr, Control).Enabled = False
        Next

        If editace Then
            Select Case rezim
                Case 1 ' vkladani noveho
                    Me.tbAdrUlo.Enabled = True
                    Me.cmbTypPalety.Enabled = True
                Case 2 'premistit
                    Me.tbAdrUlo.Enabled = True
                Case 3 'rezervace
                    Me.cmbMaterial.Enabled = True
            End Select
        End If


    End Sub


    Private Sub btnVlozit_Click(sender As Object, e As EventArgs) Handles btnVlozit.Click
        RezimEditace(True, 1)

        Dim id As Integer = NajdiMaximalniHodnotuVTabulce(DsData.tblPalety, "ID_Palety")

        With DsData.tblPalety
            .ID_PaletyColumn.DefaultValue = id + 1
            .Adr_UloColumn.DefaultValue = "Mimo"
            .ID_Typ_PaletyColumn.DefaultValue = 1
            .ID_Stav_PaColumn.DefaultValue = 1
            .Mnoz_PaColumn.DefaultValue = 0
            .KomentColumn.DefaultValue = ""
        End With


        TblPaletyBindingSource.AddNew()

        tbAdrUlo.Focus()



    End Sub

    Private Sub btnVratit_Click(sender As Object, e As EventArgs) Handles btnVratit.Click
        TblPaletyBindingSource.CancelEdit()
        RezimEditace(False, 0)
    End Sub


    Private Sub btnUlozit_Click(sender As Object, e As EventArgs) Handles btnUlozit.Click
        Try
            TblPaletyBindingSource.EndEdit()
            TblPaletyTableAdapter.Update(DsData.tblPalety)
        Catch ex As Exception
            VypisChybu(ex, "Paletu se nepodařilo uložit do databáze.")
        End Try

        RezimEditace(False, 0)

        TblPaletyBindingSource_PositionChanged(sender, e)
    End Sub

    Private Sub btnZmenit_Click(sender As Object, e As EventArgs) Handles btnZmenit.Click
        ''test, zda je vyskladnena

        If TblPaletyBindingSource.Current("ID_Stav_Pa") <> StavyPalet.Vyskladnena Then

            MsgBox("Paleta " & TblPaletyBindingSource.Current("ID_Palety") & " není vyskladněna", MsgBoxStyle.Information & MsgBoxStyle.OkOnly, "INFORMACE")
            Exit Sub

        Else

            RezimEditace(True, 2)
            tbAdrUlo.Focus()


        End If


    End Sub

    Sub RezimEditaceZmenaObsahu(editace As Boolean)

        pnlAkce.Enabled = Not editace
        pnlNavig.Enabled = Not editace
        btnZavrit.Enabled = Not editace
        pnlZasklVyskl.Enabled = Not editace
        dgvPalety.Enabled = Not editace

        For Each ctr As Control In pnlZmenaObsahu.Controls
            If ctr.Name = "btnZmenaObsahu" Then
                ctr.Enabled = Not editace
            Else
                ctr.Enabled = editace
            End If
        Next

        If Not editace Then mtbMnozstvi.Text = ""

    End Sub

    Sub RefreshNavrhovanemnozstvi()
        If rbPridat.Checked Then
            mtbMnozstvi.Text = TblMaterialBindingSource.Current("Mnoz_Do_Pal") - TblPaletyBindingSource.Current("Mnoz_Pa")
        Else
            mtbMnozstvi.Text = TblPaletyBindingSource.Current("Mnoz_Pa")
        End If

    End Sub

    Private Sub btnZmenaObsahu_Click(sender As Object, e As EventArgs) Handles btnZmenaObsahu.Click
        If TblPaletyBindingSource.Current("ID_Stav_Pa") <> StavyPalet.Vyskladnena Then

            MsgBox("Paleta " & TblPaletyBindingSource.Current("ID_Palety") & " není vyskladněna", MsgBoxStyle.Information & MsgBoxStyle.OkOnly, "INFORMACE")
            Exit Sub
        End If

        RezimEditaceZmenaObsahu(True)
        RefreshNavrhovanemnozstvi()

    End Sub

    Private Sub rbPridat_CheckedChanged(sender As Object, e As EventArgs) Handles rbPridat.CheckedChanged
        If rbPridat.Focused Then
            RefreshNavrhovanemnozstvi()
        End If
    End Sub

    Private Sub rbUbrat_CheckedChanged(sender As Object, e As EventArgs) Handles rbUbrat.CheckedChanged
        If rbUbrat.Focused Then
            RefreshNavrhovanemnozstvi()
        End If
    End Sub

    Private Sub btnStornoMnozstvi_Click(sender As Object, e As EventArgs) Handles btnStornoMnozstvi.Click
        RezimEditaceZmenaObsahu(False)
    End Sub

    Private Sub btnOKMnozstvi_Click(sender As Object, e As EventArgs) Handles btnOKMnozstvi.Click
        Dim mnozvpa As Integer = TblPaletyBindingSource.Current("Mnoz_Pa")
        Dim mnozmax As Integer = TblMaterialBindingSource.Current("Mnoz_Do_Pal")
        Dim novemnozstvi As Integer

        If rbPridat.Checked Then

            novemnozstvi = Integer.Parse(mtbMnozstvi.Text) + mnozvpa

            If novemnozstvi > mnozmax Then
                MsgBox("Tolik se do palety nevejde.", MsgBoxStyle.Information, "INFORMACE")
                RefreshNavrhovanemnozstvi()
                Exit Sub
            End If
        Else
            novemnozstvi = mnozvpa - Integer.Parse(mtbMnozstvi.Text)

            If novemnozstvi < 0 Then
                MsgBox("Nové množství by bylo záporné.", MsgBoxStyle.Information, "INFORMACE")
                RefreshNavrhovanemnozstvi()
                Exit Sub
            End If

        End If

        TblPaletyBindingSource.Current("Mnoz_Pa") = novemnozstvi

        ''test, zda je mnozstvi 0

        If novemnozstvi = 0 Then

            If MsgBox("Z palety byl vybrán všechen materiál." & vbNewLine &
                        "Označit jako volnou?", MsgBoxStyle.Information + MsgBoxStyle.YesNo, "INFORMACE") = MsgBoxResult.Yes Then

                TblPaletyBindingSource.Current("ID_Materialu") = DBNull.Value
            End If

        End If

        Try
            TblPaletyBindingSource.EndEdit()
            TblPaletyTableAdapter.Update(DsData.tblPalety)
        Catch ex As Exception
            VypisChybu(ex, "Množství se nepodařilo v databázi změnit.")
        Finally
            RezimEditaceZmenaObsahu(False)
        End Try
        TblPaletyBindingSource_PositionChanged(Nothing, Nothing)

    End Sub

    Private Sub btnVolnePalety_Click(sender As Object, e As EventArgs) Handles btnVolnePalety.Click
        frmVolnePalety.ShowDialog()
    End Sub

    Private Sub btnRezervace_Click(sender As Object, e As EventArgs) Handles btnRezervace.Click
        RezimEditace(True, 3)
    End Sub

    Private Sub btnHledej_Click(sender As Object, e As EventArgs) Handles btnHledej.Click
        cmsHledej.Show(Cursor.Position)

        Dim col As New AutoCompleteStringCollection

        For Each row As DataRow In DsData.tblPalety.Rows
            If row.RowState <> DataRowState.Deleted AndAlso Not IsDBNull(row("Adr_Ulo")) Then col.Add(row("Adr_Ulo"))
        Next

        tstbHledani.AutoCompleteCustomSource = col
        tstbHledani.AutoCompleteMode = AutoCompleteMode.SuggestAppend
        tstbHledani.AutoCompleteSource = AutoCompleteSource.CustomSource
        tstbHledani.Focus()
    End Sub

    Private Sub tstbHledani_KeyDown(sender As Object, e As KeyEventArgs) Handles tstbHledani.KeyDown
        If e.KeyCode = Keys.Enter Then


            Dim pozice As Integer

            Try
                pozice = TblPaletyBindingSource.Find("Adr_Ulo", tstbHledani.Text)
                If pozice > -1 Then TblPaletyBindingSource.Position = pozice
            Catch ex As Exception

            End Try




            cmsHledej.Text = ""
            cmsHledej.Hide()
        End If
    End Sub


End Class